/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1998
File:               functor_list.java
Description:	      This class a list of functors
*/

import java.awt.*;

class functor_list
//class functor_list definition
{

   functor_node head;   //Points to front of LinkedList
   functor_node tail;   //Points to back of LinkedList

  public void functor_list()
  //List Constructor
  {
    head = tail = null;
  }

  public void insertNode(functor_node f, TextArea t)
  //Inserts node at end of linked list
  {
    //getList(t);
    //functor_node temp = new functor_node();
    Category A = new Category();
    Category B = new Category();
    cat_functor cf = new cat_functor();
    //getList(t);
    A = f.A;
    B = f.B;
    cf = f.f;
    //getList(t);
    //temp = f;
    if (isEmpty())
    {
       head = tail = new functor_node(A, B, cf);
       //t.append("IS EMPTY");
    }
    else
    {
       tail = tail.next = new functor_node(A, B, cf);
       //t.append("NOT EMPTY");
    }
    //getList(t);
  }

 public void getList(TextArea view)
 //Retrieves list of functors in linked list
 {
   functor_node current = head;
   view.append("------------------\n");
   while(current != null)
   {
        view.append("-> " + current.f.name + "\n");
        current = current.next;
   }
   view.append("------------------\n\n");
 }
      /*
 public void replaceNode(Category c)
 //Replaces a node with an updated version of the same node
 {
   functor_node current = head;
   while(current !=null)
   {
        if (c.name.equals(current.cat.name))
        {
           current.cat = c;
        }
        current = current.next;
   }
 }
*/
 public functor_node getNode(String name, TextArea t)
 {
   functor_node getItem = null;
   functor_node current = head;
   while(current !=null)
   {
        t.append(name + " " + current.f.name + "\n");
        if (name.equals(current.f.name))
        {
           return current;
        }
        current = current.next;
   }
   return getItem; //return null if category not in list
  }

  public boolean removeNode(String name) throws EmptyListException
  //Removes node from end of linked list
  {
    functor_node current = head;
    functor_node previous = null;

    if (isEmpty())
       throw new EmptyListException();

    if (name.equals(head.f.name))
    {
      if (head.equals(tail))
         head = tail = null;
      else
         head = head.next;
      return true;
    }
    else
    {
     while(current != null)
     {
        if (name.equals(current.next.f.name))
        {
           previous = current;  //previous is node before one being removed
           current = current.next; //current is node being removed
           previous.next = current.next; //previous.next points to current.next
           return true;
        }
        current = current.next;
     }
   }
   return false;
  }

  public boolean isEmpty()
  //Returns if the linked list is empty
  //That is, if the head of the list points to null
  {
    return (head == null);
  }
}


