/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               GDCTIntro.java
Description:	      This frame displays an intro image for GDCT as a "splash screen"
                    when the application is first opened
*/

//import statements
import java.applet.Applet;
import java.awt.*;

class GDCTIntro extends Frame
{
  int check_enter = 0;
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();

  public GDCTIntro()
  //Default constructor
  {
    this.setResizable(false);
    setTitle("GDCT");
    exit.setLabel("OK");
    this.setLayout(borderLayout1);
    resize(320,290);
  }

  public void paint(Graphics g)
  //This function "paints" onto the current frame's canvas it
  //is called when the frame is created
  {
    //Draw intro graphic
    g.drawImage(getToolkit().getImage("images/intro.jpg"), 10, 25, this);
  }
}






