/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1998
File:               functor_node.java
Description:	      This class contains the information about a functor that is
                    later stored in a linked list.
*/

class functor_node
//class functor_node definition
{
  cat_functor f;
  functor_node next;
  Category A;
  Category B;
  int functor_type;
  int saved;

  functor_node()
  //Default constructor for functor_node class
  {
    cat_functor f = new cat_functor();
    functor_node next =null;
    Category A = new Category();
    Category B = new Category();
    int functor_type = 0;
  }

  functor_node(Category newA, Category newB, cat_functor newf)
  //Alternate constructor that is applicable when category A and B
  //along with the cat_functor are included as parameters
  {
     A = newA;
     B = newB;
     f = newf;
     next = null;
  }
}
